package org.jeecg.modules.device.controller;

import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import com.aliyuncs.utils.StringUtils;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.util.oConvertUtils;
import org.jeecg.modules.device.entity.Part;
import org.jeecg.modules.device.service.IPartService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecgframework.poi.excel.ExcelImportUtil;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.entity.ImportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;
import org.jeecg.common.system.base.controller.JeecgController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;
import com.alibaba.fastjson.JSON;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.jeecg.common.aspect.annotation.AutoLog;

 /**
 * @Description: 设备部件表
 * @Author: jeecg-boot
 * @Date:   2025-01-16
 * @Version: V1.0
 */
@Api(tags="设备部件表")
@RestController
@RequestMapping("/device/part")
@Slf4j
public class PartController extends JeecgController<Part, IPartService> {
	@Autowired
	private IPartService partService;

	/**
	 * 分页列表查询
	 *
	 * @param part
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	//@AutoLog(value = "设备部件表-分页列表查询")
	@ApiOperation(value="设备部件表-分页列表查询", notes="设备部件表-分页列表查询")
	@GetMapping(value = "/list")
	public Result<IPage<Part>> queryPageList(Part part,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<Part> queryWrapper = QueryGenerator.initQueryWrapper(part, req.getParameterMap());
//		if(StringUtils.isEmpty(part.getPid())){
//			queryWrapper.isNull("pid");
//			queryWrapper.eq("is_virtual", 1);
//		}
		Page<Part> page = new Page<Part>(pageNo, pageSize);
		IPage<Part> pageList = partService.page(page, queryWrapper);
		page.getRecords().forEach(item -> {
			List<Part> parts = partService.list(new LambdaQueryWrapper<Part>()
					.eq(Part::getPid, item.getId()));
			item.setChildren(parts);
		});
		return Result.OK(pageList);
	}

	/**
	 *   添加
	 *
	 * @param part
	 * @return
	 */
	@AutoLog(value = "设备部件表-添加")
	@ApiOperation(value="设备部件表-添加", notes="设备部件表-添加")
	//@RequiresPermissions("org.jeecg.modules:bu_part:add")
	@PostMapping(value = "/add")
	public Result<String> add(@RequestBody Part part) {
		partService.save(part);
		return Result.OK("添加成功！");
	}

	/**
	 *  编辑
	 *
	 * @param part
	 * @return
	 */
	@AutoLog(value = "设备部件表-编辑")
	@ApiOperation(value="设备部件表-编辑", notes="设备部件表-编辑")
	//@RequiresPermissions("org.jeecg.modules:bu_part:edit")
	@RequestMapping(value = "/edit", method = {RequestMethod.PUT,RequestMethod.POST})
	public Result<String> edit(@RequestBody Part part) {
		partService.updateById(part);
		return Result.OK("编辑成功!");
	}

	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "设备部件表-通过id删除")
	@ApiOperation(value="设备部件表-通过id删除", notes="设备部件表-通过id删除")
	//@RequiresPermissions("org.jeecg.modules:bu_part:delete")
	@DeleteMapping(value = "/delete")
	public Result<String> delete(@RequestParam(name="id",required=true) String id) {
		partService.removeById(id);
		return Result.OK("删除成功!");
	}

	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "设备部件表-批量删除")
	@ApiOperation(value="设备部件表-批量删除", notes="设备部件表-批量删除")
	//@RequiresPermissions("org.jeecg.modules:bu_part:deleteBatch")
	@DeleteMapping(value = "/deleteBatch")
	public Result<String> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.partService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}

	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	//@AutoLog(value = "设备部件表-通过id查询")
	@ApiOperation(value="设备部件表-通过id查询", notes="设备部件表-通过id查询")
	@GetMapping(value = "/queryById")
	public Result<Part> queryById(@RequestParam(name="id",required=true) String id) {
		Part part = partService.getById(id);
		if(part==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(part);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param part
    */
    //@RequiresPermissions("org.jeecg.modules:bu_part:exportXls")
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, Part part) {
        return super.exportXls(request, part, Part.class, "设备部件表");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    //@RequiresPermissions("bu_part:importExcel")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, Part.class);
    }

}
